/**---------------------------------------------------------------------
***  
***  sample1.c
***
***-------------------------------------------------------------------*/


/*  include files  */

#include <stdio.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/BulletinB.h>


/*  Functions defined in this program  */

void main();
void activateCB(); /* Callback for the pushbutton */


/*  Global variables  */

XmString btn_text;    /* button label pointer for compound string */
XmString label_text;  /* label pointer for compound string */


/*-------------------------------------------------------------
**  main - Main logic for xmbutton
*/
void main (argc,argv)
int argc;
char **argv;
{
  Widget       toplevel;    /*  Shell widget          */
  Widget       bboard;      /*  Bulletin board widget */
  Widget       button;      /*  Pushbutton widget     */
  Widget       label;       /*  Label widget          */
  Arg          args[10];    /*  arg list              */
  register     int n;       /*  arg count             */
  XtAppContext app_context; /*  application context   */

/*  Initialize the toolkit, create application context, open display, 
    and create a toplevel shell */
  toplevel = XtAppInitialize (&app_context, "Sample", NULL, 0, &argc,
                              argv, NULL, args, 0);

/*  Create a bulletin board widget for the pushbutton and label */
  n = 0;
  bboard = XmCreateBulletinBoard (toplevel, "bboard", args, n);

/*  Manage the bulletin board widget */
  XtManageChild (bboard);

/*  Create a compound string for the pushbutton label */
  btn_text = XmStringCreateLtoR("Exit", XmSTRING_DEFAULT_CHARSET);

/*  Set up an arglist for the pushbutton widget*/
  n = 0;
  XtSetArg (args[n], XmNlabelString, btn_text);  n++;

/*  Create the push button widget */
  button = XmCreatePushButton (bboard, "button", args, n); 

/*  Manage the pushbutton widget */
  XtManageChild (button);

/*  Create a compound string for the label widget text */
  label_text = XmStringCreateLtoR("Hello, World!", XmSTRING_DEFAULT_CHARSET);

/*  Set up an arglist for the label widget */
  n = 0;
  XtSetArg (args[n], XmNlabelString, label_text);  n++;

/*  Create the label widget */
  label = XmCreateLabel (bboard, "label", args, n); 

/*  Manage the pushbutton widget */
  XtManageChild (label);

/*  Free the compound string memory */
  XmStringFree (btn_text);
  XmStringFree (label_text);

/*  Add a callback  */
  XtAddCallback (button, XmNactivateCallback, activateCB, NULL);

/*  Realize widgets  */
  XtRealizeWidget (toplevel);

/*  Process events  */
  XtAppMainLoop (app_context);
}


/*-------------------------------------------------------------
**  activateCB - callback for button
*/
void activateCB (w, client_data, call_data) 
  Widget   w;            /*  widget id              */
  XtPointer   client_data;  /*  data from application  */
  XtPointer   call_data;    /*  data from widget class */
{
/*  Print message and terminate program  */
  printf ("Pushbutton Activated.\n");
  exit (0);
}

